;**********************************************************************************************************************
;**********************************************************************************************************************
;6502-only VBXE blitter example, Thelen jan '23. Can be assembled with Mads. 
;Please set manually the correct VBXE base adress, I wanted to make
;a minimal, clear to oversee (in my eyes) example. Probably this can be done much better,
;I'm not a programmer ;-)

;This source needs the file 'tiles_header_removed.bmp' to assemble this source. 
;This .bmp is the stripped down version of'Tiles.bmp' with only pixeldata



VBXE_BASE		EQU	$D600 ;<<<<<<<<<<<<<<<<<<<<<<<<<<<-----set the VBXE ADDRESS HERE


;Memac bank size= 4096 bytes, Window= $8000-$8FFF

;BANK 0-11     = DISPLAY VRAM VBXE ($00000-$0BFFF) (256x192 pixel, 1 byte a pixel)
;BANK 12       = XDL($0C000-$0C00C) & blitterlist ($0C00D-$0C034)
;BANK 13       = Bitmapdata from file:tiles_header_removed.bmp ($0D000-0DFFF)


SDLSTL	EQU	$0230		;LOW  DLIST ADRESS
SDMCTL	EQU	$022F		;DMA ENABLE/CONTROL		
COLR0	EQU	$02C4
COLR1	EQU	$02C5
COLR2	EQU	$02C6
COLR3	EQU	$02C7
COLR4	EQU	$02C8		;BACKGROUND
COLPF0	EQU	$D016		;PF0 SHADOW
COLPF1	EQU	$D017		;PF1
COLPF2	EQU	$D018		;PF2
COLPF3	EQU	$D019		;PF3	
COLBK	EQU	$D01A		;BACKGROUND SHADOW REG
RAMTOP	EQU	$006A		;HIGHEST AVAILABLE PAGE NUMBER RAM ADRESS
PMBASE	EQU	$D407		;STARTING ADRESS PLAYER MISSILE GRAPHICS
DMACTL	EQU	$D400		;PLAYFIELD/PLAYERS RESOLUTION
GRACTL	EQU	$D01D		;A 3 TURNS P/M ON
HPOSP0	EQU	$D000		;HORIZONTAL POSITION P0
HPOSP1	EQU	$D001
HPOSP2	EQU	$D002
HPOSP3	EQU	$D003
HPOSM1	EQU	$D005		;HORIZONTAL POSITION M1
HPOSM2	EQU	$D006
PCOLR0	EQU	$02C0		;COLOR P0/M0
PCOLR1	EQU	$02C1
PCOLR2	EQU	$02C2
PCOLR3	EQU	$02C3
VDSLST	EQU	$0200		;LOW BYTE DISPLAY LIST INTERRUPT ROUTINE
NMIEN	EQU	$D40E		;ENABLE NONMASKABLE INTERRUPT D7 SET=DLI D6 SET=VBI D7+D6=C0
CHBAS	EQU	$02F4		;CHARACTER ADRESS BASE
STRIG0	EQU	$0284		;JOYSTICK BUTTON 0
VSCROL	EQU	$D405		;VERTICAL FINE SCROLLING
HSCROL	EQU	$D404		;HORIZONTAL FINE SCROLLING
WSYNC	EQU	$D40A		;WAIT FOR SYNC
STICK0	EQU	$0278		;JOYSTICK 0
STICK1	EQU	$0279		;JOYSTICK 1
SETVBV	EQU	$E45C		;VBLANK OS ROUTINE
XITVBV	EQU	$E462		;VBLANK EXIT OS ROUTINE
P0PF	EQU 	$D004		;COLLISION BETWEEN PLAYFIELD NR.. AND PLAYER0
HPOSM0	EQU	$D004
P1PF	EQU	$D005		;COLLISION BETWEEN PLAYFIELD NR AND PLAYER1    
M1PF	EQU	$D001 	
M2PF	EQU	$D002
HITCLR	EQU	$D01E		;CLEAR COLLISION REGISTER
RANDOM	EQU	$D20A		;RANDOM NUMBER
GPRIOR	EQU	$026F		;PF/PLAYER PRIORITY
COLOPM0	EQU	$D012
COLOPM1	EQU	$D013
COLOPM2	EQU	$D014
COLOPM3	EQU	$D015
SIZEP0	EQU	$D008		;SIZE OF P0/M0 0=SINGLE 1=DOUBLE 3=QUADRUPLE
SIZEP1	EQU	$D009
SIZEP2	EQU	$D00A
SIZEP3	EQU	$D00B
VCOUNT	EQU	$D40B
PRIOR	EQU	$D01B
AUDF1 	EQU	$D200		;AUDIO#0 FREQ
AUDC1 	EQU	$D201 		;AUDIO#0 CONTROL
AUDF2 	EQU	$D202	
AUDC2 	EQU	$D203 	
AUDF3 	EQU	$D204		
AUDC3 	EQU	$D205 		
AUDF4 	EQU	$D204		
AUDC4 	EQU	$D205 		
AUDCTL	EQU	$D208	
SKCTL	EQU	$D20F	
P3PL	EQU	$D00F
P2PL	EQU	$D00E
PORTB	EQU	$D301



;**********************************************************
;vbxe equates
;**********************************************************

VBXE_VIDEO_CONTROL	equ	VBXE_BASE+0x40
VBXE_XDL_ADR0		equ	VBXE_BASE+0x41
VBXE_MINOR		equ	VBXE_BASE+0x41
VBXE_XDL_ADR1		equ	VBXE_BASE+0x42
VBXE_XDL_ADR2		equ	VBXE_BASE+0x43
VBXE_CSEL		equ	VBXE_BASE+0x44
VBXE_PSEL		equ	VBXE_BASE+0x45
VBXE_CR		equ	VBXE_BASE+0x46
VBXE_CG		equ	VBXE_BASE+0x47
VBXE_CB		equ	VBXE_BASE+0x48
VBXE_COLMASK		equ	VBXE_BASE+0x49
VBXE_COLCLR		equ	VBXE_BASE+0x4a
VBXE_MB_CTL		equ	VBXE_BASE+0x5d
VBXE_MA_CTL		equ	VBXE_BASE+0x5e
VBXE_MA_BSEL		equ	VBXE_BASE+0x5f
VBXE_BL_ADR0		equ	VBXE_BASE+0x50
VBXE_BL_ADR1		equ	VBXE_BASE+0x51
VBXE_BL_ADR2		equ	VBXE_BASE+0x52
VBXE_BLITTER_START	equ	VBXE_BASE+0x53
VBXE_BLITTER_BUSY	equ	VBXE_BASE+0x53
VBXE_IRQ_CONTROL	equ	VBXE_BASE+0x54



;**********************************************************
;VARIABLES
;**********************************************************
VTMP	EQU	$5F0		
TMP1	EQU	$5F1
TMP2	EQU	$5F2
TMP3	EQU	$5F3
TMP4	EQU	$5F4
TMP5	EQU	$5F5
TMP6           EQU            $5F6
TMPS	EQU	$5F7
VBXE	EQU	$5F8
PX	EQU	$5F9
PY	EQU	$5FA
VBFLAG	EQU	$5FB


;**********************************************************
;SET RUN ADRESS
;**********************************************************
	ORG	$2E0		
	DTA	$00,$90


;**********************************************************
;START ADDRESS
;**********************************************************
	ORG	$9000



;************************************************************************************************************
;SETUP ATARI
;************************************************************************************************************
	LDA	#0	;No sound
	STA	AUDCTL

  	LDA    	#$00	;Set all playfield colors to black
       	STA    	COLR4
        	STA     	COLR0
        	STA     	COLR1
        	STA     	COLR2
        	STA     	COLR3		

	LDY	#<VBLANK	;Vblank routine	
  	LDX	#>VBLANK

	LDA	#$07	;Defferred vblank
  	JSR	SETVBV

	LDA	#$C0
	STA	NMIEN



;************************************************************************************************************
;SETUP VBXE
;************************************************************************************************************

;Memac bank size= 4096 bytes, Window= $8000-$8FFF

;BANK 0-11     = DISPLAY VRAM VBXE ($00000-$0BFFF) (256x192 pixel, 1 byte a pixel)
;BANK 12       = XDL($0C000-$0C00C) & blitterlist ($0C00D-$0C034)
;BANK 13       = Bitmapdata from file:tiles_header_removed.bmp ($0D000-0DFFF)


	;LDA	#4	;4 FOR VBXE
	;STA	GPRIOR


;We set the MEMAC window (shared memory between VBXE &ATARI) starting at $8000 =$80
;CPU access active = $08
;set the bank size/MEMAC window to $1000/4Kb = $00
	LDA	#$80+$08+$00	
	STA	VBXE_MA_CTL	

;Now we select ram-bank 12 ($0C000-$0CFFF) from the VBXE. This is where we put the XDL and our 2 Blitterblocks which are the blitterlist
	LDA	#128+12	;MEMAC enabled(128) + selected bank 12
	STA	VBXE_MA_BSEL   ;set this to VBXE

;now we copy the XDL and the blitterlist (2 blitterblocks) to bank 12
;the xdl will be in VBXE ram from $0C000 - $0C00C
;The Blitterlist will be in VBXE ram from $0C00D - $0C034
;The XDL & Blitterlist data can be found at the end of this source in the data.
	LDX	#0	;Copy the XDL+blitterblock datat to VBXE RAM
COPY_XDL_BLIT	LDA	XDL_AND_BLITTERLIST_DATA,X
	STA	$8000,X        ;store this data into the MEMAC
	INX
	CPX	#$0C+(2*$15)+$01	;$0C IS THE LENGTH OF THE XDL, $14 is the length of 1 blitterblock -so this is multplied by 2, $01 is the inx end check
	BNE	COPY_XDL_BLIT  ;copy the next byte


;now we set the XDL location so that VBXE can find it:
;the XDL is starts at $0C000
	LDY	#$00
	STY	VBXE_XDL_ADR0	;XDL address low byte
               LDX            #$C0
	STX	VBXE_XDL_ADR1  ;XDL address mid byte
	STY	VBXE_XDL_ADR2	;XDL address high byte

;We also set the the location where the blitterlist starts:
;the blitterlist starts at $0C00D
	LDA	#$0D          	
	STA	VBXE_BL_ADR0   ;Blitterlist address low byte         
	STX	VBXE_BL_ADR1   ;Blitterlist address mid byte
	STY	VBXE_BL_ADR2   ;Blitterlist address High byte	
	

;The VBXE can use up to 4 palettes, in this source we set palette 0
;We load 256 RGB values to set the colors 0-255 of palette 0.
;In this example we want to show the image from the 'Tiles.bmp' file. Thus the
;color palette is extracted from the 'Tiles.bmp' file - extracted with the 'RGB-extracter'.exe
;which is also in the folder 'bronbestanden'
	LDX	#0	               ;set x to 0
	STX	VBXE_PSEL		;we want to set palette 0
	STX	VBXE_CSEL 		;start to set color 0, no increase needed, By CB is auto inc.
LOAD_PALETTE	LDA	coltab_r,X
	STA	VBXE_CR		;RED
	LDA	coltab_g,X
	STA	VBXE_CG		;GREEN
	LDA	coltab_b,X
	STA	VBXE_CB 		;BLUE - when setting blue there will be a auto increase done to set the next color(no inc of CSEL neede)
	INX
	CPX	#0                            ;are all 256 colors done?
	BNE	LOAD_PALETTE                  ;not yet, continue setting the palette


;Now erase the defined VBXE VRAM in $00000-$0BFFF (bank 0-11)
;it's timeconsuming to clear 44K :-)
               LDY            #$00           ;When Y=$00 the requested banks will be erased(set to $00)
               LDA            #128+0        ;start erasing on bank 0
               LDX            #128+11        ;stop after erasing bank 11
               JSR            copy_bigdata   ;copy it with above parameters with this subroutine.




;now copy the bitmapdata from the file(see datasection underneath this source)'tiles_header_removed.bmp'
;from Atari ram location $2000-$2FFF to the VBXE RAM in bank 16 $10000-$10FFF. Set the parameters for this subroutine:
               LDY            #$20           ;The bitmapdata in Atari Ram starts at $2000, until $2FFF
               LDA            #128+13        ;copy this to bank 13 VBXE Ram
               LDX            #128+13        ;stop copying after bank 13 VBXE ram
               JSR            copy_bigdata   ;copy it with above parameters with this subroutine.



;**********************************************************
;Start Visualiation of VBXE & prepare start main loop
;**********************************************************

   	LDA	#1
	STA	VBXE_VIDEO_CONTROL	;Make VBXE active
    	LDA	#0
    	STA	VBXE_CG		;Disable collision check
    	STA	VBXE_IRQ_CONTROL	;Disable IRQ
     

;Memac enabled(128) + select bank 12, we will modify a blitterblock destination adress, and
;the blitterlist is resident in bank 12
	LDA	#128+12	
	STA	VBXE_MA_BSEL




;**********************************************************
;START OF MAIN LOOP
;**********************************************************
LOOP	
;Start to execute the blitterlist
	LDA	#1
	STA	VBXE_BLITTER_START
;we don't check or wait until the blitterlist is done, because it's a small list :-)


;we want to move blitterblock 2 in VRAM, which is displaying the candles, so we
;increase the destination vram address of this 2nd blitterblock by inreasing byte 40 of the blitterlist: which 
;is the low byte destination address of the 2nd blitterblock. By doing this the candles
;will move horizontally
               inc            $8000+$28


               

;Wait for vertical blank to begin
WAITVBI        LDA	VBFLAG		
	BEQ	WAITVBI
	LDA	#0
	STA	VBFLAG
	JMP	LOOP




;**********************************************************
;VERTICAL BLANK ROUTINE
;**********************************************************
	
VBLANK	LDA	#255
	STA	VBFLAG
	JMP	XITVBV









;********************************************************************************************************************
;********************************************************************************************************************
;********************************************Some useful subroutines*************************************************
;********************************************************************************************************************
;********************************************************************************************************************


;***********************************************************
;copy (big) data to VBXE memmory banks
;***********************************************************

;copies from specified Atari Ram adres to specified VBXE bank(s)- only chunks of 4K (which is the MEMAC size...)
;That is just what that does, sorry no line documentation
;And yes, this routine could be optmized, probably ;-)

;takes:
;y=high byte of Atari ram address to start copy from: ($20=$2000) - when y=$00 it will clear(set all bytes to 0) to the banks specified by A and X
;a=128+..start to copy to bank?
;x=128+..last bank to fill

;modifies
;X,Y,A, tmp1...tmp6

copy_bigdata	
               stx            tmp5           ;=last bank to fill (128+x)
	STY	TMP1	;high byte bmp data
	sty	TMP6
	sta	TMP4	;sla de startbank op
next_bank	lda	TMP4	;laad de bank
	STA	VBXE_MA_BSEL
	lda	#0
	sta	TMP3	;counts series of 256 done(16*256)=4k = memac
	LDY	>$8000	;MEMEAC start adres $8000
	STY	TMP2	;high byte memac
	LDX	#$00	;
inc_low	LDY	TMP1
	lda	TMP6
	bne	aha
	lda	#0
	jmp	wishier	
aha	JSR	CHECPOS
wishier	LDY	TMP2
	JSR	PUTPOS
	INX
	CPX	#$00
	BNE	inc_low
	inc	TMP1
	inc	TMP2
	lda	TMP2
	cmp	>$8000+$1000	;16 sets of 256(4K)+$80 =$90=over end of memac
	BNE	inc_low
	inc	TMP3
	lda	TMP3
	cmp	#2	;2 sets van 4K laden
	lda	TMP4
	cmp            tmp5           ;is this the last bank to fill?
	beq	end_copy_big_data
	inc	tmp4
	jmp	next_bank
end_copy_big_data
               RTS




;***********************************************************
;Check on ram location
;***********************************************************
;takes:
;Y=High byte
;X=Low byte

;returns
;A= byte on that location

;modifies:
;TMPS
;$B3
;$B2

CHECPOS
	STY	$B3
	STX	$B2
	STY	TMPS
	LDY	#0
	LDA	($B2),Y
	LDY	TMPS
	RTS



;***********************************************************
;Put on ram location
;***********************************************************
;takes:
;Y=High byte
;X=Low byte
;A= byte for that location

;modifies:
;TMPS
;$B3
;$B2
	
PUTPOS		
	STY	$B3
	STX	$B2
	STY	TMPS
	LDY	#0
	STA	($B2),Y
	LDY	TMPS
	RTS





;********************************************************************************************************************
;********************************************************************************************************************
;********************************************  all types of Data    *************************************************
;********************************************************************************************************************
;********************************************************************************************************************




;*******************************************************
;VBXE PALETTE DATA
;*******************************************************
coltab_r   .byte 0,255,252,251,0,0,0,71,0,0,87,59,241,252,251,2,133,76,252,52,159,152,128,141,38,207,190,216,216,215,128,124,123,24,224,149,44,150,200,132,181,173,16,17,16,17,37,39,39,39,0,0,0,0,0,0,5,0,0,0,5,0,0,28,28,28,28,28,28,0,0,0,0,0,0,0,0,0,0,0,28,28,28,0,0,0,0,28,28,28,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,24,17,23,22,37,37,10,10,10,10,0,0,5,0,0,0,5,0,0,28,36,2,36,36,36,0,0,0,0,0,0,0,0,0,0,0,36,0,2,0,0,0,0,28,0,28,0,0,28,0,0,28,28,0,0,2,2,0,0,18,0,0,30,16,17,17,21,23,22,37,20,10,20,10,0,5,4,0,0,5,4,0,0,36,2,28,36,36,2,0,0,0,0,0,0,0,0,28,0,0,28,0,28,0,0,0,0,36,0,2,0,28,0,0,0,2,29,0,2,0,0,0,31,18,32,0,30,17,16,17,21,23,23,37,20,20,20,20,0,0,41,0,0,0,41,0,0,36
coltab_g   .byte 0,255,116,116,0,0,6,101,73,91,104,74,234,216,216,1,95,61,152,27,65,62,52,59,31,97,153,39,40,39,123,13,12,13,23,31,42,145,195,130,181,173,17,16,24,17,37,39,39,39,0,0,0,0,0,5,4,0,0,5,4,0,0,28,28,28,28,28,28,0,0,0,0,0,0,0,0,0,0,0,28,36,28,0,0,0,0,28,28,28,28,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,24,30,37,22,22,37,10,10,10,10,0,5,4,0,0,5,4,0,0,28,36,2,28,36,36,0,0,0,0,0,0,0,0,0,0,0,28,28,36,0,0,0,0,28,0,2,0,0,28,0,0,28,29,0,0,3,2,0,0,18,32,0,30,16,17,24,21,23,22,37,20,10,20,10,0,4,4,0,0,4,4,0,0,36,36,28,36,2,2,0,0,0,0,0,0,0,0,0,0,0,36,0,2,0,28,0,0,28,28,28,0,0,0,0,0,28,2,0,2,0,0,2,0,18,18,0,17,17,17,17,21,21,23,22,20,20,20,20,0,41,1,0,0,41,1,0,0,36
coltab_b   .byte 0,255,180,180,255,141,25,154,36,36,91,36,53,168,168,0,57,46,56,9,3,4,4,6,27,43,135,0,0,0,122,0,0,12,17,27,42,145,195,130,181,173,24,16,24,16,0,39,39,39,0,0,0,0,0,4,0,0,0,4,0,0,0,0,28,28,28,28,28,0,0,0,0,0,0,0,0,0,0,0,28,36,28,28,0,0,0,0,28,28,28,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,17,16,38,22,22,37,0,10,0,10,0,4,0,0,0,4,0,0,0,28,36,2,36,36,36,0,0,0,0,0,0,0,0,0,0,0,0,28,28,28,28,0,0,0,0,2,0,0,36,0,0,0,28,0,0,2,2,0,0,18,18,0,17,16,17,24,38,23,23,22,40,20,40,20,0,4,4,0,0,4,4,0,0,28,36,28,28,36,36,0,28,0,0,0,0,0,0,0,0,0,28,0,36,0,36,0,0,0,28,0,28,0,28,0,0,28,2,29,0,0,0,2,0,18,18,0,17,16,17,17,38,21,23,22,40,20,40,20,0,1,0,0,0,1,0,0,0,28






XDL_AND_BLITTERLIST_DATA
;*******************************************************
;VBXE XDL
;*******************************************************
	.BYTE	$24	;DISABLE OVERLAY(FOR BLANKING), SET REPEAT THIS ANOTHER NEXT X SCANLINES
	.BYTE	$00  
	.BYTE	23	;REPEAT 23 LINES
	.BYTE	$72	;EN. GR.OVERLAY, DIS.COL.ATT.,SET REPEAT THIS ANOTHER X SCANLINES, SET ADDRESS + SET STEP OVERLAY VRAM.
	.BYTE	$88	;SET OVATT(SET DISPLAY SIZE+PRIORITY), XDL END
	.BYTE	192-8	;Repeat this for 192-8 lines
	.BYTE	$00,$00,$00	;Overlay address = $00000. So VRAM starts at $00000 of VBXE
	.BYTE	$00,$01	;Step =$0100 256 Pixels      
	.BYTE	$00,$FF	;OVATT, WIDTH ($00=width=256 pixels, PRIORITY ($FF = Over all player/missile and playfield graphics)

;*******************************************************
;Blitterlist
;*******************************************************
;Blitterblock 1
;this blitterblock will copy the whole bitmap data from the file (tiles_header_removed.bmp) loaded in bank 13 to the VBXE VRAM
	.byte $00,$D0,$00 	; source addr, low/mid/high byte $00D000
	.byte $00,$01     	; Step source Y low byte, high byte = $100 = 256 pixels
	.byte 1		; Step source X
	.byte $00,$00,$00 	; dest. addr,low/mid/high byte  $000000 is the first pixel of the defined video ram of VBXE
	.byte $00,$01 		; Step destination Y low byte, high byte = $100 = 256 pixels
	.byte 1		; Step destination X
        	.byte $FF,$00  	; obj width low byte, high byte = 256 pixels wide
        	.byte $0f   		; obj height = 16 pixels high
        	.byte $ff    		; AND FF
        	.byte $00       	; XOR
        	.byte 0       		; collision AND
        	.byte $00       	; zoom
        	.byte 0       		; pattern
        	.byte 8                       ; control byte : 8 = there is a next blitterblock. 33

;Blitterblock 2
;this blitterblock will copy the second candle from the Tiles.BMP to the VBXE defined display ram.
	.byte $40,$D0,$00 	; source addr, low/mid/high byte $00D000
	.byte $00,$01     	; Step source Y low byte, high byte = $100 = 256 pixels
	.byte 1		; Step source X
	.byte $00,$20,$00 	; dest. addr,low/mid/high byte  $000000 is the first pixel of the defined video ram of VBXE
	.byte $00,$01 		; Step destination Y low byte, high byte = $100 = 256 pixels
	.byte 1		; Step destination X
        	.byte $0F,$00  	; obj width low byte, high byte = 16 pixels wide
        	.byte $0F   		; obj height = 16 pixels high
        	.byte $ff    		; AND FF
        	.byte $00       	; XOR
        	.byte 0       		; collision AND
        	.byte $00       	; zoom
        	.byte 0       		; pattern
        	.byte 0                       ; control byte : 0 = this was the last blitterblock of the blitterlist



;*******************************************************
;Bitmap file, header etc. is removed- so only bitmapdata
;*******************************************************
	ORG	$2000
	ins	"tiles_header_removed.bmp"


